#include "ti83plusklein.inc"
#define B_CALL(xxxx) rst 28h \ .dw xxxx
#define B_JUMP(xxxx) call 50h \ .dw xxxx

SC_Cursor      =    $E2

Delay          =    $28

     .org 9D95h
     
ProgStart:
     
;*****************************
     
     XOR  a
     ld   (IY+textflags),a
     ld   (IY+indicflags),a
     
Clear:
     B_CALL(_clrscrnfull)
     B_CALL(_homeup)
     
     ld   hl,TXT_GUI
     B_CALL(_puts)
     
     ld   hl,$0002
     ld   (currow),hl
     
     ld   bc,$0008
     ld   de,_op1 + 7
     ld   hl,_op1 + 8
     
     ld   (hl),b
     LDDR
     
     INC  e
     INC  e
     
;*****************************
     
PreGetCSC:
     call CLL_SwitchCursor
     ld   b,Delay
     
GetCSC:
     EI
     HALT
     B_CALL(_getcsc)
     OR   a
     jr   nz,KeyPress
     DJNZ GetCSC
     jr   PreGetCSC
     
;*****************************
     
KeyPress:
     res  curon,(IY+curflags)
     ld   bc,DAT_KeyCodes_End - DAT_KeyCodes + 1
     ld   hl,DAT_KeyCodes_End - 1
     
     CPDR
     
     ld   a,c
     OR   a
     jr   z,PreGetCSC
     
     SUB  2
     jp   c,Enter
     jr   z,Mode
     SUB  2
     jr   c,Delete
     jr   z,Clear
     
     ld   b,a
     
     set  curon,(IY+curflags)
     call CLL_SwitchCursor
     
     ld   a,b
     
     SUB  2
     jr   c,Right
     jr   z,Down
     SUB  2
     jr   c,Left
     jr   z,Up
     
     ADD  a,$40
     B_CALL(_putmap)
     ld   (de),a
     
     ld   a,(curcol)
     cp   7
     jr   z,PreGetCSC
     
     INC  a
     INC  e
     ld   (curcol),a
     jr   PreGetCSC
     
;*****************************
     
Mode:
     B_CALL(_clrscrnfull)
     B_CALL(_homeup)
     RET
     
;*****************************
     
Delete:
     ld   a,(_op1 + 8) & $00FF
     ld   h,d
     ld   l,e
     SUB  e
     jr   z,Delete_LC
     
     ld   b,0
     ld   c,a
     INC  l
     
     ld   a,e
     
     LDIR
     
     ld   e,a
     ld   l,a
     XOR  a
Delete_LC:
     ld   (_op1+8),a
     
     B_CALL(_puts)
     ld   a,$20
     B_CALL(_putmap)
     ld   a,e
     SUB  (_op1 + 1) & $00FF
     ld   (curcol),a
     jp   PreGetCSC
     
;*****************************
     
Up:
     ld   e,(_op1 + 1) & $00FF
     ld   (curcol),a
     jp   PreGetCSC
     
Down:
     ld   bc,$0008
     ld   hl,_op1 + 1
     
     CPIR
     
     DEC  l
     ld   a,l
     ld   e,l
     
     SUB  (_op1 + 1) & $00FF
     ld   (curcol),a
     jp   PreGetCSC
     
Left:
     ld   a,(curcol)
     OR   a
     jp   z,PreGetCSC
     
     DEC  a
     DEC  e
     ld   (curcol),a
     jp   PreGetCSC
     
Right:
     ld   a,(de)
     OR   a
     jp   z,PreGetCSC
     ld   a,(curcol)
     cp   7
     jp   z,PreGetCSC
     
     INC  a
     INC  e
     ld   (curcol),a
     jp   PreGetCSC
     
;*****************************
     
Enter:
     B_CALL(_chkfindsym)
     jr   c,Exists_Not
     
     B_CALL(_delvararc)
     
Exists_Not:
     ld   hl,ProgEnd - ProgStart + 2
     B_CALL(_createprotprog)
     
     INC  de
     INC  de
     
     ld   a,t2bytetok
     ld   (de),a
     INC  de
     ld   a,tasmcmp
     ld   (de),a
     INC  de
     
     ld   bc,ProgEnd - ProgStart
     ld   hl,ProgStart
     
     LDIR
     
     jp   Mode
     
;*****************************
     
CLL_SwitchCursor:
     ld   a,SC_Cursor
     bit  curon,(IY+curflags)
     set  curon,(IY+curflags)
     jr   z,CLL_SC_CurOn
     
     ld   a,(de)
     res  curon,(IY+curflags)
     
     OR   a
     jr   nz,CLL_SC_CurOn
     
     ld   a,$20
     
CLL_SC_CurOn:
     B_CALL(_putmap)
     RET
     
;*****************************
     
DAT_KeyCodes:
     .db  skenter             ;<Enter>
     .db  skmode              ;<Mode>
     .db  skdel               ;<Delete>
     .db  skclear             ;<Clear>
     
     .db  skright             ;<Right>
     .db  skdown              ;<Down>
     .db  skleft              ;<Left>
     .db  skup                ;<Up>
     
     .db  $2F,$27,$1F         ;A B C
     .db  $2E,$26,$1E,$16,$0E ;D E F G H
     .db  $2D,$25,$1D,$15,$0D ;I J K L M
     .db  $2C,$24,$1C,$14,$0C ;N O P Q R
     .db  $2B,$23,$1B,$13,$0B ;S T U V W
     .db  $2A,$22,$1A         ;X Y Z
DAT_KeyCodes_End:
     
TXT_GUI:
     .db  "Progname:",0
     
ProgEnd:
     
     .end
END
